## Command IDs Command IDs — Generic command handling routines. |

## Functions

gboolean | mbim_cid_can_set ()
gboolean | mbim_cid_can_query ()
gboolean | mbim_cid_can_notify ()
const gchar * | mbim_cid_get_printable ()
const gchar * | mbim_cid_atds_get_string ()
const gchar * | mbim_cid_basic_connect_get_string ()
const gchar * | mbim_cid_sms_get_string ()
const gchar * | mbim_cid_ussd_get_string ()
const gchar * | mbim_cid_phonebook_get_string ()
const gchar * | mbim_cid_stk_get_string ()
const gchar * | mbim_cid_auth_get_string ()
const gchar * | mbim_cid_dss_get_string ()
const gchar * | mbim_cid_ms_firmware_id_get_string ()
const gchar * | mbim_cid_ms_host_shutdown_get_string ()
const gchar * | mbim_cid_proxy_control_get_string ()
const gchar * | mbim_cid_qmi_get_string ()
const gchar * | mbim_cid_qdu_get_string ()
const gchar * | mbim_cid_intel_firmware_update_get_string ()
const gchar * | mbim_cid_ms_basic_connect_extensions_get_string ()
const gchar * | mbim_cid_ms_sar_get_string ()
const gchar * | mbim_cid_ms_uicc_low_level_access_get_string ()
const gchar * | mbim_cid_quectel_get_string ()

## Types and Values

enum | MbimCidAtds
enum | MbimCidBasicConnect
enum | MbimCidSms
enum | MbimCidUssd
enum | MbimCidPhonebook
enum | MbimCidStk
enum | MbimCidAuth
enum | MbimCidDss
enum | MbimCidMsFirmwareId
enum | MbimCidMsHostShutdown
enum | MbimCidProxyControl
enum | MbimCidQmi
enum | MbimCidQdu
enum | MbimCidIntelFirmwareUpdate
enum | MbimCidMsBasicConnectExtensions
enum | MbimCidMsSar
enum | MbimCidMsUiccLowLevelAccess
enum | MbimCidQuectel

## Object Hierarchy

        GEnum
        ├── MbimCidAtds
        ├── MbimCidAuth
        ├── MbimCidBasicConnect
        ├── MbimCidDss
        ├── MbimCidIntelFirmwareUpdate
        ├── MbimCidMsBasicConnectExtensions
        ├── MbimCidMsFirmwareId
        ├── MbimCidMsHostShutdown
        ├── MbimCidMsSar
        ├── MbimCidMsUiccLowLevelAccess
        ├── MbimCidPhonebook
        ├── MbimCidProxyControl
        ├── MbimCidQdu
        ├── MbimCidQmi
        ├── MbimCidQuectel
        ├── MbimCidSms
        ├── MbimCidStk
        ╰── MbimCidUssd

## Description

This section defines the interface of the known command IDs.

## Functions

### mbim_cid_can_set ()

    gboolean
    mbim_cid_can_set (MbimService service,
                      guint cid);

Checks whether the given command allows setting.

#### Parameters

service | a MbimService. |
cid | a command ID. |

#### Returns

`TRUE` if the command allows setting, `FALSE` otherwise.

Since: 1.0

### mbim_cid_can_query ()

    gboolean
    mbim_cid_can_query (MbimService service,
                        guint cid);

Checks whether the given command allows querying.

#### Parameters

service | a MbimService. |
cid | a command ID. |

#### Returns

`TRUE` if the command allows querying, `FALSE` otherwise.

Since: 1.0

### mbim_cid_can_notify ()

    gboolean
    mbim_cid_can_notify (MbimService service,
                         guint cid);

Checks whether the given command allows notifying.

#### Parameters

service | a MbimService. |
cid | a command ID. |

#### Returns

`TRUE` if the command allows notifying, `FALSE` otherwise.

Since: 1.0

### mbim_cid_get_printable ()

    const gchar *
    mbim_cid_get_printable (MbimService service,
                            guint cid);

Gets a printable string for the command specified by the `service` and the `cid` .

#### Parameters

service | a MbimService. |
cid | a command ID. |

#### Returns

a constant string.

Since: 1.0

### mbim_cid_atds_get_string ()

    const gchar *
    mbim_cid_atds_get_string (MbimCidAtds val);

Gets the nickname string for the MbimCidAtds specified at `val` .

#### Parameters

val | a MbimCidAtds. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.16

### mbim_cid_basic_connect_get_string ()

    const gchar *
    mbim_cid_basic_connect_get_string (MbimCidBasicConnect val);

Gets the nickname string for the MbimCidBasicConnect specified at `val` .

#### Parameters

val | a MbimCidBasicConnect. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_sms_get_string ()

    const gchar *
    mbim_cid_sms_get_string (MbimCidSms val);

Gets the nickname string for the MbimCidSms specified at `val` .

#### Parameters

val | a MbimCidSms. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_ussd_get_string ()

    const gchar *
    mbim_cid_ussd_get_string (MbimCidUssd val);

Gets the nickname string for the MbimCidUssd specified at `val` .

#### Parameters

val | a MbimCidUssd. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_phonebook_get_string ()

    const gchar *
    mbim_cid_phonebook_get_string (MbimCidPhonebook val);

Gets the nickname string for the MbimCidPhonebook specified at `val` .

#### Parameters

val | a MbimCidPhonebook. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_stk_get_string ()

    const gchar *
    mbim_cid_stk_get_string (MbimCidStk val);

Gets the nickname string for the MbimCidStk specified at `val` .

#### Parameters

val | a MbimCidStk. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_auth_get_string ()

    const gchar *
    mbim_cid_auth_get_string (MbimCidAuth val);

Gets the nickname string for the MbimCidAuth specified at `val` .

#### Parameters

val | a MbimCidAuth. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_dss_get_string ()

    const gchar *
    mbim_cid_dss_get_string (MbimCidDss val);

Gets the nickname string for the MbimCidDss specified at `val` .

#### Parameters

val | a MbimCidDss. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_ms_firmware_id_get_string ()

    const gchar *
    mbim_cid_ms_firmware_id_get_string (MbimCidMsFirmwareId val);

Gets the nickname string for the MbimCidMsFirmwareId specified at `val` .

#### Parameters

val | a MbimCidMsFirmwareId. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cid_ms_host_shutdown_get_string ()

    const gchar *
    mbim_cid_ms_host_shutdown_get_string (MbimCidMsHostShutdown val);

Gets the nickname string for the MbimCidMsHostShutdown specified at `val` .

#### Parameters

val | a MbimCidMsHostShutdown. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.8

### mbim_cid_proxy_control_get_string ()

    const gchar *
    mbim_cid_proxy_control_get_string (MbimCidProxyControl val);

Gets the nickname string for the MbimCidProxyControl specified at `val` .

#### Parameters

val | a MbimCidProxyControl. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.10

### mbim_cid_qmi_get_string ()

    const gchar *
    mbim_cid_qmi_get_string (MbimCidQmi val);

Gets the nickname string for the MbimCidQmi specified at `val` .

#### Parameters

val | a MbimCidQmi. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### mbim_cid_qdu_get_string ()

    const gchar *
    mbim_cid_qdu_get_string (MbimCidQdu val);

Gets the nickname string for the MbimCidQdu specified at `val` .

#### Parameters

val | a MbimCidQdu. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_cid_intel_firmware_update_get_string ()

    const gchar *
    mbim_cid_intel_firmware_update_get_string
                                   (MbimCidIntelFirmwareUpdate val);

Gets the nickname string for the MbimCidIntelFirmwareUpdate specified at `val` .

#### Parameters

val | a MbimCidIntelFirmwareUpdate. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.16

### mbim_cid_ms_basic_connect_extensions_get_string ()

    const gchar *
    mbim_cid_ms_basic_connect_extensions_get_string
                                   (MbimCidMsBasicConnectExtensions val);

Gets the nickname string for the MbimCidMsBasicConnectExtensions specified at `val` .

#### Parameters

val | a MbimCidMsBasicConnectExtensions. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### mbim_cid_ms_sar_get_string ()

    const gchar *
    mbim_cid_ms_sar_get_string (MbimCidMsSar val);

Gets the nickname string for the MbimCidMsSar specified at `val` .

#### Parameters

val | a MbimCidMsSar. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_cid_ms_uicc_low_level_access_get_string ()

    const gchar *
    mbim_cid_ms_uicc_low_level_access_get_string
                                   (MbimCidMsUiccLowLevelAccess val);

Gets the nickname string for the MbimCidMsUiccLowLevelAccess specified at `val` .

#### Parameters

val | a MbimCidMsUiccLowLevelAccess. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_cid_quectel_get_string ()

    const gchar *
    mbim_cid_quectel_get_string (MbimCidQuectel val);

Gets the nickname string for the MbimCidQuectel specified at `val` .

#### Parameters

val | a MbimCidQuectel. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26.2

## Types and Values

### enum MbimCidAtds

MBIM commands in the `MBIM_SERVICE_ATDS` service.

#### Members

MBIM_CID_ATDS_UNKNOWN | Unknown command. |
MBIM_CID_ATDS_SIGNAL | Radio signal information. |
MBIM_CID_ATDS_LOCATION | Cell location information. |
MBIM_CID_ATDS_OPERATORS | Operator selection. |
MBIM_CID_ATDS_RAT | Radio Access Technology selection. |
MBIM_CID_ATDS_REGISTER_STATE | Registration state. |

Since: 1.16

### enum MbimCidBasicConnect

MBIM commands in the `MBIM_SERVICE_BASIC_CONNECT` service.

#### Members

MBIM_CID_BASIC_CONNECT_UNKNOWN | Unknown command. |
MBIM_CID_BASIC_CONNECT_DEVICE_CAPS | Device capabilities. |
MBIM_CID_BASIC_CONNECT_SUBSCRIBER_READY_STATUS | Subscriber ready status. |
MBIM_CID_BASIC_CONNECT_RADIO_STATE | Radio state. |
MBIM_CID_BASIC_CONNECT_PIN | PIN. |
MBIM_CID_BASIC_CONNECT_PIN_LIST | PIN list. |
MBIM_CID_BASIC_CONNECT_HOME_PROVIDER | Home provider. |
MBIM_CID_BASIC_CONNECT_PREFERRED_PROVIDERS | Preferred providers. |
MBIM_CID_BASIC_CONNECT_VISIBLE_PROVIDERS | Visible providers. |
MBIM_CID_BASIC_CONNECT_REGISTER_STATE | Register state. |
MBIM_CID_BASIC_CONNECT_PACKET_SERVICE | Packet service. |
MBIM_CID_BASIC_CONNECT_SIGNAL_STATE | Signal state. |
MBIM_CID_BASIC_CONNECT_CONNECT | Connect. |
MBIM_CID_BASIC_CONNECT_PROVISIONED_CONTEXTS | Provisioned contexts. |
MBIM_CID_BASIC_CONNECT_SERVICE_ACTIVATION | Service activation. |
MBIM_CID_BASIC_CONNECT_IP_CONFIGURATION | IP configuration. |
MBIM_CID_BASIC_CONNECT_DEVICE_SERVICES | Device services. |
MBIM_CID_BASIC_CONNECT_DEVICE_SERVICE_SUBSCRIBE_LIST | Device service subscribe list. Since 1.8. |
MBIM_CID_BASIC_CONNECT_PACKET_STATISTICS | Packet statistics. |
MBIM_CID_BASIC_CONNECT_NETWORK_IDLE_HINT | Network idle hint. |
MBIM_CID_BASIC_CONNECT_EMERGENCY_MODE | Emergency mode. |
MBIM_CID_BASIC_CONNECT_IP_PACKET_FILTERS | IP packet filters. |
MBIM_CID_BASIC_CONNECT_MULTICARRIER_PROVIDERS | Multicarrier providers. |

Since: 1.0

### enum MbimCidSms

MBIM commands in the `MBIM_SERVICE_SMS` service.

#### Members

MBIM_CID_SMS_UNKNOWN | Unknown command. |
MBIM_CID_SMS_CONFIGURATION | SMS configuration. |
MBIM_CID_SMS_READ | Read. |
MBIM_CID_SMS_SEND | Send. |
MBIM_CID_SMS_DELETE | Delete. |
MBIM_CID_SMS_MESSAGE_STORE_STATUS | Store message status. |

Since: 1.0

### enum MbimCidUssd

MBIM commands in the `MBIM_SERVICE_USSD` service.

#### Members

MBIM_CID_USSD_UNKNOWN | Unknown command. Since 1.4. |
MBIM_CID_USSD | USSD operation. |

Since: 1.0

### enum MbimCidPhonebook

MBIM commands in the `MBIM_SERVICE_PHONEBOOK` service.

#### Members

MBIM_CID_PHONEBOOK_UNKNOWN | Unknown command. |
MBIM_CID_PHONEBOOK_CONFIGURATION | Configuration. |
MBIM_CID_PHONEBOOK_READ | Read. |
MBIM_CID_PHONEBOOK_DELETE | Delete. |
MBIM_CID_PHONEBOOK_WRITE | Write. |

Since: 1.0

### enum MbimCidStk

MBIM commands in the `MBIM_SERVICE_STK` service.

#### Members

MBIM_CID_STK_UNKNOWN | Unknown command. |
MBIM_CID_STK_PAC | PAC. |
MBIM_CID_STK_TERMINAL_RESPONSE | Terminal response. |
MBIM_CID_STK_ENVELOPE | Envelope. |

Since: 1.0

### enum MbimCidAuth

MBIM commands in the `MBIM_SERVICE_AUTH` service.

#### Members

MBIM_CID_AUTH_UNKNOWN | Unknow command |
MBIM_CID_AUTH_AKA | AKA. |
MBIM_CID_AUTH_AKAP | AKAP. |
MBIM_CID_AUTH_SIM | SIM. |

Since: 1.0

### enum MbimCidDss

MBIM commands in the `MBIM_SERVICE_DSS` service.

#### Members

MBIM_CID_DSS_UNKNOWN | Unknown command. |
MBIM_CID_DSS_CONNECT | Connect. |

Since: 1.0

### enum MbimCidMsFirmwareId

MBIM commands in the `MBIM_SERVICE_MS_FIRMWARE_ID` service.

#### Members

MBIM_CID_MS_FIRMWARE_ID_UNKNOWN | Unknown command. |
MBIM_CID_MS_FIRMWARE_ID_GET | Get Firmware ID. |

Since: 1.8

### enum MbimCidMsHostShutdown

MBIM commands in the `MBIM_SERVICE_MS_HOST_SHUTDOWN` service.

#### Members

MBIM_CID_MS_HOST_SHUTDOWN_UNKNOWN | Unknown command. |
MBIM_CID_MS_HOST_SHUTDOWN_NOTIFY | Notify that the host is shutting down. |

Since: 1.8

### enum MbimCidProxyControl

MBIM commands in the `MBIM_SERVICE_PROXY_CONTROL` service.

#### Members

MBIM_CID_PROXY_CONTROL_UNKNOWN | Unknown command. |
MBIM_CID_PROXY_CONTROL_CONFIGURATION | Configuration. |

Since: 1.10

### enum MbimCidQmi

MBIM commands in the `MBIM_SERVICE_QMI` service.

#### Members

MBIM_CID_QMI_UNKNOWN | Unknown command. |
MBIM_CID_QMI_MSG | Send QMI request and receive QMI response. |

Since: 1.14

### enum MbimCidQdu

MBIM commands in the `MBIM_SERVICE_QDU` service.

#### Members

MBIM_CID_QDU_UNKNOWN | Unknown command. |
MBIM_CID_QDU_UPDATE_SESSION | Update session command. |
MBIM_CID_QDU_FILE_OPEN | Open QDU file for firmware update. |
MBIM_CID_QDU_FILE_WRITE | Write QDU file for firmware update. |

Since: 1.26

### enum MbimCidIntelFirmwareUpdate

MBIM commands in the `MBIM_SERVICE_INTEL_FIRMWARE_UPDATE` service.

#### Members

MBIM_CID_INTEL_FIRMWARE_UPDATE_UNKNOWN | Unknown command. |
MBIM_CID_INTEL_FIRMWARE_UPDATE_MODEM_REBOOT | Reboot modem for firmware update. |

Since: 1.16

### enum MbimCidMsBasicConnectExtensions

MBIM commands in the `MBIM_SERVICE_MS_BASIC_CONNECT_EXTENSIONS` service.

#### Members

MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_UNKNOWN | Unknown command. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_PROVISIONED_CONTEXTS | Provisioned contexts (v2). |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_NETWORK_BLACKLIST | Network blacklist. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_LTE_ATTACH_CONFIGURATION | LTE attach configuration. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_LTE_ATTACH_INFO | LTE attach status information. Since 1.26. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_SYS_CAPS | System capabilities. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_DEVICE_CAPS | Device capabilities (v2). |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_DEVICE_SLOT_MAPPINGS | Device slot mappings. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_SLOT_INFO_STATUS | Slot info status. |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_PCO | Protocol configuration operations (PCO). |
MBIM_CID_MS_BASIC_CONNECT_EXTENSIONS_DEVICE_RESET | Device reset. |

Since: 1.18

### enum MbimCidMsSar

MBIM commands in the `MBIM_SERVICE_MS_SAR` service.

#### Members

MBIM_CID_MS_SAR_UNKNOWN | Unknown command. |
MBIM_CID_MS_SAR_CONFIG | SAR backoff mode and level configuration. |
MBIM_CID_MS_SAR_TRANSMISSION_STATUS | Transmission status indication setup. |

Since: 1.26

### enum MbimCidMsUiccLowLevelAccess

MBIM commands in the `MBIM_SERVICE_MS_UICC_LOW_LEVEL_ACCESS` service.

#### Members

MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_UNKNOWN | Unknown command. |
MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_ATR | ATR. |
MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_OPEN_CHANNEL | Open Channel. |
MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_CLOSE_CHANNEL | Close Channel. |
MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_APDU | Apdu. |
MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_TERMINAL_CAPABILITY | Terminal capabilities. |
MBIM_CID_MS_UICC_LOW_LEVEL_ACCESS_RESET | Reset. |

Since: 1.26

### enum MbimCidQuectel

MBIM commands in the `MBIM_SERVICE_QUECTEL` service.

#### Members

MBIM_CID_QUECTEL_UNKNOWN | Unknown command. |
MBIM_CID_QUECTEL_RADIO_STATE | Radio state. |

Since: 1.26.2